"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _validationError = require("../validation-error/validation-error");

var _propTypesTemplates = require("@data-driven-forms/common/prop-types-templates");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TextField = function TextField(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      inputProps = _useFieldApi.inputProps,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "inputProps", "FormFieldGridProps"]);

  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_TextField["default"], (0, _extends2["default"])({}, input, {
    fullWidth: true,
    error: !!invalid,
    helperText: invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description,
    disabled: isDisabled,
    label: label,
    placeholder: placeholder,
    required: isRequired,
    inputProps: _objectSpread({
      readOnly: isReadOnly
    }, inputProps)
  }, rest)));
};

TextField.propTypes = {
  input: _propTypesTemplates.input,
  meta: _propTypesTemplates.meta,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  helperText: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  description: _propTypes["default"].node,
  inputProps: _propTypes["default"].object,
  FormFieldGridProps: _propTypes["default"].object
};
var _default = TextField;
exports["default"] = _default;