"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _clsx = _interopRequireDefault(require("clsx"));

var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));

var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _styles = require("@material-ui/core/styles");

var NextButton = function NextButton(_ref) {
  var nextStep = _ref.nextStep,
      valid = _ref.valid,
      handleNext = _ref.handleNext,
      nextLabel = _ref.nextLabel,
      getState = _ref.getState,
      handleSubmit = _ref.handleSubmit,
      submitLabel = _ref.submitLabel,
      conditionalSubmitFlag = _ref.conditionalSubmitFlag;
  var nextResult = nextStep ? (0, _selectNext["default"])(nextStep, getState) : nextStep;
  var progressNext = nextResult !== conditionalSubmitFlag && nextStep;
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    variant: "contained",
    color: "primary",
    disabled: !valid || getState().validating || getState().submitting,
    onClick: function onClick() {
      return progressNext ? handleNext(nextResult) : handleSubmit();
    }
  }, progressNext ? nextLabel : submitLabel);
};

NextButton.propTypes = {
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func, _propTypes["default"].object]),
  handleSubmit: _propTypes["default"].func.isRequired,
  submitLabel: _propTypes["default"].node.isRequired,
  valid: _propTypes["default"].bool,
  handleNext: _propTypes["default"].func.isRequired,
  nextLabel: _propTypes["default"].node.isRequired,
  getState: _propTypes["default"].func.isRequired,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired
};
var useStyles = (0, _styles.makeStyles)(function () {
  return {
    wizardBody: {
      padding: 24,
      margin: 0
    },
    buttons: {
      display: 'flex',
      justifyContent: 'flex-end'
    },
    button: {
      marginRight: 16
    },
    buttonsContainer: {
      marginTop: 36
    }
  };
});

var WizardStepButtons = function WizardStepButtons(_ref2) {
  var Buttons = _ref2.buttons,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["buttons"]);
  var classes = useStyles();

  if (Buttons) {
    return /*#__PURE__*/_react["default"].createElement(Buttons, (0, _extends2["default"])({
      classes: classes
    }, props));
  }

  var disableBack = props.disableBack,
      handlePrev = props.handlePrev,
      nextStep = props.nextStep,
      handleNext = props.handleNext,
      _props$buttonLabels = props.buttonLabels,
      cancel = _props$buttonLabels.cancel,
      submit = _props$buttonLabels.submit,
      back = _props$buttonLabels.back,
      next = _props$buttonLabels.next,
      formOptions = props.formOptions,
      ButtonContainerProps = props.ButtonContainerProps,
      conditionalSubmitFlag = props.conditionalSubmitFlag;
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    direction: "row",
    justify: "space-evenly"
  }, ButtonContainerProps, {
    className: (0, _clsx["default"])(classes.buttonsContainer, ButtonContainerProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      values: true,
      valid: true,
      validating: true,
      submitting: true
    }
  }, function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      md: 2,
      xs: 2
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: formOptions.onCancel
    }, cancel)), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      md: 10,
      xs: 10,
      className: classes.buttons
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      disabled: disableBack,
      onClick: handlePrev,
      className: classes.button
    }, back), /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
      conditionalSubmitFlag: conditionalSubmitFlag,
      handleNext: handleNext,
      nextStep: nextStep,
      nextLabel: next,
      submitLabel: submit
    }))));
  }));
};

WizardStepButtons.propTypes = {
  ButtonContainerProps: _propTypes["default"].object,
  disableBack: _propTypes["default"].bool,
  handlePrev: _propTypes["default"].func.isRequired,
  handleNext: _propTypes["default"].func.isRequired,
  conditionalSubmitFlag: _propTypes["default"].string.isRequired,
  nextStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].shape({
    when: _propTypes["default"].string.isRequired,
    stepMapper: _propTypes["default"].object.isRequired
  }), _propTypes["default"].func]),
  buttonLabels: _propTypes["default"].shape({
    submit: _propTypes["default"].node.isRequired,
    cancel: _propTypes["default"].node.isRequired,
    back: _propTypes["default"].node.isRequired,
    next: _propTypes["default"].node.isRequired
  }).isRequired,
  buttons: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  formOptions: _propTypes["default"].shape({
    getState: _propTypes["default"].func.isRequired,
    onCancel: _propTypes["default"].func.isRequired
  })
};
WizardStepButtons.defaultProps = {
  ButtonContainerProps: {}
};
var _default = WizardStepButtons;
exports["default"] = _default;